'    GPS  EB-500
'    Nokia3310
'exersizze 2013 AVRproject.ru

$regfile = "m32def.dat"
$crystal = 11059200
$baud = 115200

$hwstack = 32                                               ' default
$swstack = 8                                                ' default
$framesize = 64


Declare Sub Getline(s As String)
Declare Sub Flushbuf()


Dim S As String * 80                                        '  
Dim B As Byte
Dim R As Byte
Dim Z As String * 4

Dim Ns As String * 1                                        ' N/S
Dim Ew As String * 1                                        ' E/W

Dim Shirota As String * 10                                  '
Dim Dolgota As String * 10                                  '

Dim Grad_shirota As String * 2                              ' 
Dim Grad_dolgota As String * 3                              ' 

Dim Minuta_shirota As String * 2                            ' 
Dim Minuta_dolgota As String * 2                            ' 

Dim Second_shirota As String * 4                            ' 
Dim Second_dolgota As String * 4                            ' 

Dim Temp As Single                                          '   

Dim Skorost As String * 6                                   ' 
Dim Azimut As String * 3                                    '   

Dim Hour As String * 2                                      '
Dim Minut As String * 2                                     ' 
Dim Second As String * 2                                    ' 





Config Porta.3 = Output                                     '   
 Power_lcd Alias Porta.3
Power_lcd = 1

Config Porta.4 = Output                                     '   
Backlight Alias Porta.4
Backlight = 1


' I/O  3310
'========================================================================================
'========================================================================================
Config Porta.0 = Output                                     'D/C (pin 4)
D3310dc Alias Porta.0

Config Portb.3 = Output                                     'SCE (pin 5)
D3310ce Alias Portb.3

Config Portb.4 = Output                                     'Reset (pin 8)
D3310re Alias Portb.4

' SPI   . SCLK (pin 2) - PORTA.2; SDA (pin 3) - PORTA.1; Din  
Config Spi = Soft , Din = Porta.5 , Dout = Porta.1 , Ss = None , Clock = Porta.2

Spiinit

$include "3310init.bas"

' SPI
Call D3310reset
Call D3310init
Call D3310clear


'    
Restore D3310bmp1                                           ' 
Call D3310bmpout
Wait 1
Call D3310position(3 , 5)
Call D3310print( "EB-500 TEST")
Wait 25

'    $GPRMC
' 
'$GPRMC,190813.000,A,5312.7581,N,05009.1821,E,0.30,256.15,231212,,,A*62

Do

R = Ischarwaiting()                                         '    
  If R = 1 Then
     Getline S                                              '      
     Z = Left(s , 4)                                        '  4 
        If Z = "$GPR" Then

           Shirota = Mid(s , 21 , 9)                        '5312.7581
           Dolgota = Mid(s , 33 , 10)                       '05009.1821

           Z = Left(shirota , 1)                            '  ","     ,    
           If Z <> "," Then

            Ns = Mid(s , 31 , 1 )                           'N
            Ew = Mid(s , 44 , 1)                            'E

            Backlight = 0                                   '  

            '      
            Grad_shirota = Left(shirota , 2 )
            Minuta_shirota = Mid(shirota , 3 , 2)
            Second_shirota = Right(shirota , 4)
             Temp = Val(second_shirota)                     '7581
             Temp = Temp * 60                               '454860
             Temp = Temp / 10000                            '45,486
            Second_shirota = Fusing(temp , "##.##")         '45.49



            Grad_dolgota = Left(dolgota , 3 )
            Minuta_dolgota = Mid(dolgota , 4 , 2)
            Second_dolgota = Right(dolgota , 4)
             Temp = Val(second_dolgota)                     '1821
             Temp = Temp * 60                               '109260
             Temp = Temp / 10000                            '10,926
            Second_dolgota = Fusing(temp , "##.##")         '10,93



            '    
            Skorost = Mid(s , 46 , 4)                       '0.30 ( )
             Temp = Val(skorost)
             Temp = Temp * 1.852                            '  /
            Skorost = Str(temp )
            Skorost = Format(skorost , "000.00")

            Azimut = Mid(s , 51 , 3 )                       '256  (   )


            ' UTC
            Hour = Mid(s , 8 , 2)                           '19
            Minut = Mid(s , 10 , 2)                         '08
            Second = Mid(s , 12 , 2)                        '13



           Call D3310clear
           Call D3310position(0 , 0)                        '   
           Call D3310print(ns)
           Call D3310position(1 , 0)
           Call D3310print(grad_shirota)
           Call D3310position(3 , 0)
           Call D3310print( "")
           Call D3310position(4 , 0)
           Call D3310print(minuta_shirota)
           Call D3310position(6 , 0)
           Call D3310print( "'")
           Call D3310position(7 , 0)
           Call D3310print(second_shirota)
           Call D3310position(12 , 0)
           Call D3310print( "@")                            '  3310   
           Call D3310position(13 , 0)
           Call D3310print( " ")


           Call D3310position(0 , 1)                        ' 
           Call D3310print(ew)
           Call D3310position(1 , 1)
           Call D3310print(grad_dolgota)
           Call D3310position(4 , 1)
           Call D3310print( "")
           Call D3310position(5 , 1)
           Call D3310print(minuta_dolgota)
           Call D3310position(7 , 1)
           Call D3310print( "'")
           Call D3310position(8 , 1)
           Call D3310print(second_dolgota)
           Call D3310position(13 , 1)
           Call D3310print( "@")


           Call D3310position(0 , 2)                        ' 
           Call D3310print(skorost)
           Call D3310position(6 , 2)
           Call D3310print( "/")
           Call D3310position(10 , 2)
           Call D3310print( "   ")



           Call D3310position(0 , 3)
           Call D3310print( "")
           Call D3310position(5 , 3)                        ' 
           Call D3310print(azimut)
           Call D3310position(8 , 3)
           Call D3310print( "")


           Call D3310position(0 , 5)                        ' 
           Call D3310print(hour)
           Call D3310position(2 , 5)
           Call D3310print( ":")
           Call D3310position(3 , 5)
           Call D3310print(minut)
           Call D3310position(5 , 5)
           Call D3310print( ":")
           Call D3310position(6 , 5)
           Call D3310print(second)



          Flushbuf                                          '  

          Else
           Call D3310clear
           Call D3310position(0 , 0)
           Call D3310print( "...")
           Backlight = 1                                    '     
           Flushbuf
          End If
        End If
  End If


Loop


End

$include "3310end.bas"
$include "3310bmp1.bas"



'    
'=============================================================================
Sub Getline(s As String)
   S = ""
   Do
      B = Inkey()                                           '      ASCII
      Select Case B
          Case 10 : If S <> "" Then Exit Do                 ' ,    
          Case Else : If B > 31 Then S = S + Chr(b)         '     32   ,    
      End Select
  Loop
End Sub

' 
'=============================================================================
Sub Flushbuf()
 Waitms 10
 Do
 B = Inkey()                                                '   
 Loop Until B = 0
End Sub